<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Version' => '\\StructType\\Version',
            'AuthentificationType' => '\\StructType\\AuthentificationType',
            'NativeAddressType' => '\\StructType\\NativeAddressType',
            'NativeAddressTypeNew' => '\\StructType\\NativeAddressTypeNew',
            'ReceiverNativeAddressType' => '\\StructType\\ReceiverNativeAddressType',
            'PickupAddressType' => '\\StructType\\PickupAddressType',
            'DeliveryAddressType' => '\\StructType\\DeliveryAddressType',
            'BankType' => '\\StructType\\BankType',
            'NameType' => '\\StructType\\NameType',
            'ReceiverNameType' => '\\StructType\\ReceiverNameType',
            'CommunicationType' => '\\StructType\\CommunicationType',
            'ContactType' => '\\StructType\\ContactType',
            'PackStationType' => '\\StructType\\PackStationType',
            'PostfilialeType' => '\\StructType\\PostfilialeType',
            'PostfilialeTypeNoCountry' => '\\StructType\\PostfilialeTypeNoCountry',
            'ParcelShopType' => '\\StructType\\ParcelShopType',
            'CustomerType' => '\\StructType\\CustomerType',
            'ErrorType' => '\\StructType\\ErrorType',
            'CountryType' => '\\StructType\\CountryType',
            'ShipmentNumberType' => '\\StructType\\ShipmentNumberType',
            'Status' => '\\StructType\\Status',
            'Dimension' => '\\StructType\\Dimension',
            'TimeFrame' => '\\StructType\\TimeFrame',
            'GetVersionResponse' => '\\StructType\\GetVersionResponse',
            'CreateShipmentOrderRequest' => '\\StructType\\CreateShipmentOrderRequest',
            'ValidateShipmentOrderRequest' => '\\StructType\\ValidateShipmentOrderRequest',
            'CreateShipmentOrderResponse' => '\\StructType\\CreateShipmentOrderResponse',
            'ValidateShipmentResponse' => '\\StructType\\ValidateShipmentResponse',
            'GetLabelRequest' => '\\StructType\\GetLabelRequest',
            'GetLabelResponse' => '\\StructType\\GetLabelResponse',
            'DoManifestRequest' => '\\StructType\\DoManifestRequest',
            'DoManifestResponse' => '\\StructType\\DoManifestResponse',
            'DeleteShipmentOrderRequest' => '\\StructType\\DeleteShipmentOrderRequest',
            'DeleteShipmentOrderResponse' => '\\StructType\\DeleteShipmentOrderResponse',
            'GetExportDocRequest' => '\\StructType\\GetExportDocRequest',
            'GetExportDocResponse' => '\\StructType\\GetExportDocResponse',
            'GetManifestRequest' => '\\StructType\\GetManifestRequest',
            'GetManifestResponse' => '\\StructType\\GetManifestResponse',
            'UpdateShipmentOrderRequest' => '\\StructType\\UpdateShipmentOrderRequest',
            'UpdateShipmentOrderResponse' => '\\StructType\\UpdateShipmentOrderResponse',
            'CreationState' => '\\StructType\\CreationState',
            'ValidationState' => '\\StructType\\ValidationState',
            'Statusinformation' => '\\StructType\\Statusinformation',
            'StatusElement' => '\\StructType\\StatusElement',
            'PieceInformation' => '\\StructType\\PieceInformation',
            'ShipmentOrderType' => '\\StructType\\ShipmentOrderType',
            'Shipment' => '\\StructType\\Shipment',
            'ValidateShipmentOrderType' => '\\StructType\\ValidateShipmentOrderType',
            'ShipperTypeType' => '\\StructType\\ShipperTypeType',
            'ShipperType' => '\\StructType\\ShipperType',
            'ReceiverTypeType' => '\\StructType\\ReceiverTypeType',
            'ReceiverType' => '\\StructType\\ReceiverType',
            'Ident' => '\\StructType\\Ident',
            'ShipmentDetailsType' => '\\StructType\\ShipmentDetailsType',
            'ShipmentDetailsTypeType' => '\\StructType\\ShipmentDetailsTypeType',
            'ShipmentItemType' => '\\StructType\\ShipmentItemType',
            'ShipmentItemTypeType' => '\\StructType\\ShipmentItemTypeType',
            'ShipmentService' => '\\StructType\\ShipmentService',
            'Serviceconfiguration' => '\\StructType\\Serviceconfiguration',
            'ServiceconfigurationDetails' => '\\StructType\\ServiceconfigurationDetails',
            'ServiceconfigurationDetailsPreferredDay' => '\\StructType\\ServiceconfigurationDetailsPreferredDay',
            'ServiceconfigurationDetailsPreferredLocation' => '\\StructType\\ServiceconfigurationDetailsPreferredLocation',
            'ServiceconfigurationDetailsPreferredNeighbour' => '\\StructType\\ServiceconfigurationDetailsPreferredNeighbour',
            'ServiceconfigurationDetailsOptional' => '\\StructType\\ServiceconfigurationDetailsOptional',
            'ServiceconfigurationDetailsResponse' => '\\StructType\\ServiceconfigurationDetailsResponse',
            'ServiceconfigurationType' => '\\StructType\\ServiceconfigurationType',
            'ServiceconfigurationEndorsement' => '\\StructType\\ServiceconfigurationEndorsement',
            'ServiceconfigurationISR' => '\\StructType\\ServiceconfigurationISR',
            'ServiceconfigurationDH' => '\\StructType\\ServiceconfigurationDH',
            'ServiceconfigurationVisualAgeCheck' => '\\StructType\\ServiceconfigurationVisualAgeCheck',
            'ServiceconfigurationDeliveryTimeframe' => '\\StructType\\ServiceconfigurationDeliveryTimeframe',
            'ServiceconfigurationDateOfDelivery' => '\\StructType\\ServiceconfigurationDateOfDelivery',
            'ServiceconfigurationAdditionalInsurance' => '\\StructType\\ServiceconfigurationAdditionalInsurance',
            'ServiceconfigurationCashOnDelivery' => '\\StructType\\ServiceconfigurationCashOnDelivery',
            'ServiceconfigurationUnfree' => '\\StructType\\ServiceconfigurationUnfree',
            'PDDP' => '\\StructType\\PDDP',
            'ServiceconfigurationIC' => '\\StructType\\ServiceconfigurationIC',
            'ShipmentNotificationType' => '\\StructType\\ShipmentNotificationType',
            'ExportDocumentType' => '\\StructType\\ExportDocumentType',
            'ExportDocPosition' => '\\StructType\\ExportDocPosition',
            'FurtherAddressesType' => '\\StructType\\FurtherAddressesType',
            'DeliveryAdress' => '\\StructType\\DeliveryAdress',
            'LabelData' => '\\StructType\\LabelData',
            'ExportDocData' => '\\StructType\\ExportDocData',
            'ManifestState' => '\\StructType\\ManifestState',
            'DeletionState' => '\\StructType\\DeletionState',
            'BookPickupRequest' => '\\StructType\\BookPickupRequest',
            'BookPickupResponse' => '\\StructType\\BookPickupResponse',
            'PickupDetailsType' => '\\StructType\\PickupDetailsType',
            'PickupOrdererType' => '\\StructType\\PickupOrdererType',
            'PickupBookingInformationType' => '\\StructType\\PickupBookingInformationType',
            'CancelPickupRequest' => '\\StructType\\CancelPickupRequest',
            'CancelPickupResponse' => '\\StructType\\CancelPickupResponse',
            'IdentityData' => '\\StructType\\IdentityData',
            'DrivingLicense' => '\\StructType\\DrivingLicense',
            'IdentityCard' => '\\StructType\\IdentityCard',
            'BankCard' => '\\StructType\\BankCard',
            'PackstationType' => '\\StructType\\PackstationType_1',
            'ReadShipmentOrderResponse' => '\\StructType\\ReadShipmentOrderResponse',
        );
    }
}
